-- Testbed Setup 

USE master 
GO 
DROP TABLE ReplicationTestbed_Publisher.dbo.Table1 
GO 
DROP TABLE ReplicationTestbed_Subscriber.dbo.Table1 
GO 
--
USE ReplicationTestbed_Publisher 
CREATE TABLE ReplicationTestbed_Publisher.dbo.Table1 
( col1 int IDENTITY ( 1 , 1 ) PRIMARY KEY CLUSTERED 
    , col2 int 
) 
--
USE ReplicationTestbed_Subscriber 
CREATE TABLE ReplicationTestbed_Subscriber.dbo.Table1 
( col1 int PRIMARY KEY CLUSTERED 
    , col2 int 
) 

-- Listing 1

USE [ReplicationTestbed_Publisher] 

EXEC sp_replicationdboption @dbname = N'ReplicationTestbed_Publisher' , @optname = N'publish' , @value = N'true' 

GO 

-- Adding the transactional publication

USE [ReplicationTestbed_Publisher] 

EXEC sp_addpublication @publication = N'ReplicationTestbed_Repl' , 
@description = N'Transactional publication of database ''ReplicationTestbed_Publisher'' from Publisher ''SERVER1''.' , 
@sync_method = N'concurrent' , @retention = 0 , @allow_push = N'true' , @allow_pull = N'true' , @allow_anonymous = N'false' , 
@enabled_for_internet = N'false' , @snapshot_in_defaultfolder = N'true' , @compress_snapshot = N'false' , @ftp_port = 21 , 
@allow_subscription_copy = N'false' , @add_to_active_directory = N'false' , @repl_freq = N'continuous' , @status = N'active' , 
@independent_agent = N'true' , @immediate_sync = N'false' , @allow_sync_tran = N'false' , @allow_queued_tran = N'false' , 
@allow_dts = N'false' , @replicate_ddl = 1 , @allow_initialize_from_backup = N'false' , @enabled_for_p2p = N'false' , 
@enabled_for_het_sub = N'false' 

GO 

USE [ReplicationTestbed_Publisher] 

EXEC sp_addarticle @publication = N'ReplicationTestbed_Repl' , @article = N'Table1' , @source_owner = N'dbo' , 
@source_object = N'Table1' , @type = N'logbased' , @description = N'' , @creation_script = NULL , @pre_creation_cmd = N'none' , 
@schema_option = 0x000000000803509F , @identityrangemanagementoption = N'manual' , @destination_table = N'Table1' , 
@destination_owner = N'dbo' , @vertical_partition = N'true' , @ins_cmd = N'CALL sp_MSins_dboTable1' , 
@del_cmd = N'CALL sp_MSdel_dboTable1' , @upd_cmd = N'SCALL sp_MSupd_dboTable1' 

-- Adding the article's partition column(s)

EXEC sp_articlecolumn @publication = N'ReplicationTestbed_Repl' , @article = N'Table1' , @column = N'col1' , @operation = N'add' , 
@force_invalidate_snapshot = 1 , @force_reinit_subscription = 1 

EXEC sp_articlecolumn @publication = N'ReplicationTestbed_Repl' , @article = N'Table1' , @column = N'col2' , @operation = N'add' , 
@force_invalidate_snapshot = 1 , @force_reinit_subscription = 1 

-- Adding the article synchronization object

EXEC sp_articleview @publication = N'ReplicationTestbed_Repl' , @article = N'Table1' , @view_name = N'SYNC_Table1_1__68' , 

@filter_clause = NULL , @force_invalidate_snapshot = 1 , @force_reinit_subscription = 1 

GO 
--subscriber
USE [ReplicationTestbed_Publisher] 

EXEC sp_addsubscription @publication = N'ReplicationTestbed_Repl' , @subscriber = N'SERVER1' , @destination_db = N'ReplicationTestbed_Subscriber' , @subscription_type = N'Push' , @sync_type = N'replication support only' , @article = N'all' , @update_mode = N'read only' , @subscriber_type = 0 

EXEC sp_addpushsubscription_agent @publication = N'ReplicationTestbed_Repl' , @subscriber = N'SERVER1' , @subscriber_db = N'ReplicationTestbed_Subscriber' , @job_login = NULL , @job_password = NULL , @subscriber_security_mode = 1 , @frequency_type = 1 , @frequency_interval = 0 , @frequency_relative_interval = 0 , @frequency_recurrence_factor = 0 , @frequency_subday = 0 , @frequency_subday_interval = 0 , @active_start_time_of_day = 0 , @active_end_time_of_day = 0 , @active_start_date = 0 , @active_end_date = 19950101 , @enabled_for_syncmgr = N'False' , @dts_package_location = N'Distributor' GO --Turn off DDL replication exec sp_changepublication @publication = N'ReplicationTestbed_Repl' , @property = 'replicate_ddl' , @value = '0' , @force_invalidate_snapshot = 0 , @force_reinit_subscription = 0

-- Listing 2

SELECT * FROM distribution. [dbo].[MSrepl_commands] WHERE publisher_database_id = 
( 
    SELECT id FROM distribution.dbo.MSpublisher_databases WHERE publisher_db = 'ReplicationTestbed_Publisher' 
) 

-- Listing 3

INSERT INTO ReplicationTestbed_Publisher.dbo.Table1 ( col2 ) VALUES ( 5 ) 
GO 
--distributor data
SELECT * FROM distribution_Acclaim. [dbo].[MSrepl_commands] WHERE publisher_database_id = 
( 
    SELECT id FROM distribution_Acclaim.dbo.MSpublisher_databases WHERE publisher_db = 'ReplicationTestbed_Publisher' 
) 

-- Listing 4

SELECT * FROM ReplicationTestbed_Publisher.dbo.Table1 

SELECT * FROM ReplicationTestbed_Subscriber.dbo.Table1 

-- Listing 5

--alter so that it only affects col3 (not replicated)

UPDATE ReplicationTestbed_Publisher.dbo.Table1 
SET col3 = 10 

-- Listing 6
--add a column for replication

ALTER TABLE ReplicationTestbed_Publisher.dbo.Table1 ADD col4 int 

--to simulate a long running transaction that is not consumed by the log reader, we can turn off the log reader

EXECUTE msdb.dbo.sp_stop_job @job_name = 'SERVER1-ReplicationTestbed_Publisher-35' 

GO 

UPDATE ReplicationTestbed_Publisher.dbo.Table1 SET col4 = 15 

SELECT * FROM ReplicationTestbed_Publisher.dbo.Table1 

SELECT * FROM ReplicationTestbed_Subscriber.dbo.Table1 

-- Listing 7

--add column to replication.  In the deployment, this is the point where we felt we waited "long enough" and can continue.

EXEC sp_articlecolumn @publication = N'ReplicationTestbed_Repl' , @article = N'Table1' , 

@column = N'col4' , @operation = N'add' , @force_invalidate_snapshot = 1 , @force_reinit_subscription = 1 

--no change to distribution data

SELECT * FROM distribution. [dbo].[MSrepl_commands] WHERE publisher_database_id = 

( 
    SELECT id FROM distribution.dbo.MSpublisher_databases WHERE publisher_db = 'ReplicationTestbed_Publisher' 
) 

--add column to staging

ALTER TABLE ReplicationTestbed_Subscriber.dbo.Table1 ADD col4 int 

--change distribution proc to match
USE ReplicationTestbed_Subscriber 
GO 
ALTER PROCEDURE [dbo].[sp_MSupd_dboTable1] 
@c1 int = NULL , 
@c2 int = NULL , 
@c4 int = NULL , 
@pkc1 int = NULL , 
@bitmap binary ( 1 ) 
AS 
BEGIN 
    UPDATE [dbo].[Table1] SET 
    [col2] = 
    CASE substring ( @bitmap , 1 , 1 ) & 2 
        WHEN 2 THEN @c2 
        ELSE [col2] 
    END 
    , 
    [col4] = 
    CASE substring ( @bitmap , 1 , 1 ) & 4 
        WHEN 4 THEN @c4 
        ELSE [col4] 
    END 
    WHERE [col1] = @pkc1 

    IF @@rowcount = 0 
    IF @@microsoftversion > 0x07320000 

    EXEC sp_MSreplraiserror 20598 
END 

-- Listing 8

--turn on log reader.  Simulating that the log reader has now consumed the large update
EXECUTE msdb.dbo.sp_start_job @job_name = 'SERVER1-ReplicationTestbed_Publisher-37' 
GO 

--change to distribution data!
SELECT * FROM distribution_Acclaim. [dbo].[MSrepl_commands] WHERE publisher_database_id = 

( 
    SELECT id FROM distribution_Acclaim.dbo.MSpublisher_databases WHERE publisher_db = 'ReplicationTestbed_Publisher' 
) 

--run distributor

--Data changed before enabled for repliation has moved

SELECT * FROM ReplicationTestbed_Publisher.dbo.Table1 

SELECT * FROM ReplicationTestbed_Subscriber.dbo.Table1 

-- Listing 9

USE ReplicationTestbed_Publisher 
GO 
ALTER TABLE ReplicationTestbed_Publisher.dbo.Table1 ADD col5 int 

--simulate long update
EXECUTE msdb.dbo.sp_stop_job @job_name = 'SERVER1-ReplicationTestbed_Publisher-35' 
GO 
UPDATE ReplicationTestbed_Publisher.dbo.Table1 SET col5 = 20 

SELECT * FROM ReplicationTestbed_Publisher.dbo.Table1 

SELECT * FROM ReplicationTestbed_Subscriber.dbo.Table1 

-- Listing 10

DECLARE @publication AS sysname; 
DECLARE @tokenID AS int; 

SET @publication = N'ReplicationTestbed_Repl' ; 

-- Insert a new tracer token in the publication database.

EXEC sys.sp_posttracertoken 
@publication = @publication , 
@tracer_token_id = @tokenID OUTPUT; 

SELECT 'The ID of the new tracer token is ''' + 
convert ( varchar , @tokenID ) + '''.' 

-- Listing 11

CREATE TABLE #token 
( distributor_latency int 
    , subscriber sysname 
    , subscriber_db sysname 
    , subscriber_latency int 
    , overall_latency int 
) 

INSERT INTO #token 

EXEC sys.sp_helptracertokenhistory 
@publication = N'ReplicationTestbed_Repl' , 
@tracer_id = - 2147472026; 

SELECT distributor_latency FROM #token 

DROP TABLE #token 

-- Listing 12
--long running transaction is done
EXECUTE msdb.dbo.sp_start_job @job_name = 'SERVER1-ReplicationTestbed_Publisher-35' 
GO 

--Verify
CREATE TABLE #token 
( distributor_latency int 
    , subscriber sysname 
    , subscriber_db sysname 
    , subscriber_latency int 
    , overall_latency int 
) 

INSERT INTO #token 

EXEC sys.sp_helptracertokenhistory 
@publication = N'ReplicationTestbed_Repl' , 
@tracer_id = - 2147472028; 

SELECT * FROM #token 

DROP TABLE #token 

-- Listing 13

EXEC sp_articlecolumn 
@publication = N'ReplicationTestbed_Repl' 
, @article = N'Table1' 
, @column = N'col5' 
, @operation = N'add' 
, @force_invalidate_snapshot = 1 
, @force_reinit_subscription = 1 

--add column to staging
ALTER TABLE ReplicationTestbed_Subscriber.dbo.Table1 ADD col5 int 

--change distribution proc to match
USE ReplicationTestbed_Subscriber 
GO 
ALTER PROCEDURE [dbo].[sp_MSupd_dboTable1] 
@c1 int = NULL , 
@c2 int = NULL , 
@c4 int = NULL , 
@c5 int = NULL , 
@pkc1 int = NULL , 
@bitmap binary ( 1 ) 
AS 
BEGIN 

    UPDATE [dbo].[Table1] 
    SET 
    [col2] = 
    CASE substring ( @bitmap , 1 , 1 ) & 2 
        WHEN 2 THEN @c2 
        ELSE [col2] 
    END 
    , [col4] = 
    CASE substring ( @bitmap , 1 , 1 ) & 4 
        WHEN 4 THEN @c4 
        ELSE [col4] 
    END 
    , [col5] = 
    CASE substring ( @bitmap , 1 , 1 ) & 8 
        WHEN 8 THEN @c5 
        ELSE [col5] 
    END 
    WHERE [col1] = @pkc1 

    IF @@rowcount = 0 
    IF @@microsoftversion > 0x07320000 

    EXEC sp_MSreplraiserror 20598 
END 

-- Listing 14

SELECT * FROM ReplicationTestbed_Publisher.dbo.Table1 

SELECT * FROM ReplicationTestbed_Subscriber.dbo.Table1